t / test-lib.shon commit Make NO_{INET_NTOP,INET_PTON} configured independently (5a857c7)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# if --tee was passed, write the output not only to the terminal, but
   7# additionally to the file test-results/$BASENAME.out, too.
   8case "$GIT_TEST_TEE_STARTED, $* " in
   9done,*)
  10        # do not redirect again
  11        ;;
  12*' --tee '*|*' --va'*)
  13        mkdir -p test-results
  14        BASE=test-results/$(basename "$0" .sh)
  15        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  16         echo $? > $BASE.exit) | tee $BASE.out
  17        test "$(cat $BASE.exit)" = 0
  18        exit
  19        ;;
  20esac
  21
  22# Keep the original TERM for say_color
  23ORIGINAL_TERM=$TERM
  24
  25# For repeatability, reset the environment to known value.
  26LANG=C
  27LC_ALL=C
  28PAGER=cat
  29TZ=UTC
  30TERM=dumb
  31export LANG LC_ALL PAGER TERM TZ
  32EDITOR=:
  33unset VISUAL
  34unset GIT_EDITOR
  35unset AUTHOR_DATE
  36unset AUTHOR_EMAIL
  37unset AUTHOR_NAME
  38unset COMMIT_AUTHOR_EMAIL
  39unset COMMIT_AUTHOR_NAME
  40unset EMAIL
  41unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  42unset GIT_AUTHOR_DATE
  43GIT_AUTHOR_EMAIL=author@example.com
  44GIT_AUTHOR_NAME='A U Thor'
  45unset GIT_COMMITTER_DATE
  46GIT_COMMITTER_EMAIL=committer@example.com
  47GIT_COMMITTER_NAME='C O Mitter'
  48unset GIT_DIFF_OPTS
  49unset GIT_DIR
  50unset GIT_WORK_TREE
  51unset GIT_EXTERNAL_DIFF
  52unset GIT_INDEX_FILE
  53unset GIT_OBJECT_DIRECTORY
  54unset GIT_CEILING_DIRECTORIES
  55unset SHA1_FILE_DIRECTORIES
  56unset SHA1_FILE_DIRECTORY
  57unset GIT_NOTES_REF
  58unset GIT_NOTES_DISPLAY_REF
  59unset GIT_NOTES_REWRITE_REF
  60unset GIT_NOTES_REWRITE_MODE
  61GIT_MERGE_VERBOSITY=5
  62export GIT_MERGE_VERBOSITY
  63export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  64export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  65export EDITOR
  66
  67if test -z "$GIT_TEST_CMP"
  68then
  69        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
  70        then
  71                GIT_TEST_CMP="$DIFF -c"
  72        else
  73                GIT_TEST_CMP="$DIFF -u"
  74        fi
  75fi
  76
  77# Protect ourselves from common misconfiguration to export
  78# CDPATH into the environment
  79unset CDPATH
  80
  81unset GREP_OPTIONS
  82
  83case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  84        1|2|true)
  85                echo "* warning: Some tests will not work if GIT_TRACE" \
  86                        "is set as to trace on STDERR ! *"
  87                echo "* warning: Please set GIT_TRACE to something" \
  88                        "other than 1, 2 or true ! *"
  89                ;;
  90esac
  91
  92# Convenience
  93#
  94# A regexp to match 5 and 40 hexdigits
  95_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  96_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  97
  98# Each test should start with something like this, after copyright notices:
  99#
 100# test_description='Description of this test...
 101# This test checks if command xyzzy does the right thing...
 102# '
 103# . ./test-lib.sh
 104[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 105                TERM=$ORIGINAL_TERM &&
 106                export TERM &&
 107                [ -t 1 ] &&
 108                tput bold >/dev/null 2>&1 &&
 109                tput setaf 1 >/dev/null 2>&1 &&
 110                tput sgr0 >/dev/null 2>&1
 111        ) &&
 112        color=t
 113
 114while test "$#" -ne 0
 115do
 116        case "$1" in
 117        -d|--d|--de|--deb|--debu|--debug)
 118                debug=t; shift ;;
 119        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 120                immediate=t; shift ;;
 121        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 122                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 123        -h|--h|--he|--hel|--help)
 124                help=t; shift ;;
 125        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 126                verbose=t; shift ;;
 127        -q|--q|--qu|--qui|--quie|--quiet)
 128                quiet=t; shift ;;
 129        --with-dashes)
 130                with_dashes=t; shift ;;
 131        --no-color)
 132                color=; shift ;;
 133        --no-python)
 134                # noop now...
 135                shift ;;
 136        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 137                valgrind=t; verbose=t; shift ;;
 138        --tee)
 139                shift ;; # was handled already
 140        --root=*)
 141                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 142                shift ;;
 143        *)
 144                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 145        esac
 146done
 147
 148if test -n "$color"; then
 149        say_color () {
 150                (
 151                TERM=$ORIGINAL_TERM
 152                export TERM
 153                case "$1" in
 154                        error) tput bold; tput setaf 1;; # bold red
 155                        skip)  tput bold; tput setaf 2;; # bold green
 156                        pass)  tput setaf 2;;            # green
 157                        info)  tput setaf 3;;            # brown
 158                        *) test -n "$quiet" && return;;
 159                esac
 160                shift
 161                printf "* %s" "$*"
 162                tput sgr0
 163                echo
 164                )
 165        }
 166else
 167        say_color() {
 168                test -z "$1" && test -n "$quiet" && return
 169                shift
 170                echo "* $*"
 171        }
 172fi
 173
 174error () {
 175        say_color error "error: $*"
 176        GIT_EXIT_OK=t
 177        exit 1
 178}
 179
 180say () {
 181        say_color info "$*"
 182}
 183
 184test "${test_description}" != "" ||
 185error "Test script did not set test_description."
 186
 187if test "$help" = "t"
 188then
 189        echo "$test_description"
 190        exit 0
 191fi
 192
 193exec 5>&1
 194if test "$verbose" = "t"
 195then
 196        exec 4>&2 3>&1
 197else
 198        exec 4>/dev/null 3>/dev/null
 199fi
 200
 201test_failure=0
 202test_count=0
 203test_fixed=0
 204test_broken=0
 205test_success=0
 206
 207die () {
 208        code=$?
 209        if test -n "$GIT_EXIT_OK"
 210        then
 211                exit $code
 212        else
 213                echo >&5 "FATAL: Unexpected exit with code $code"
 214                exit 1
 215        fi
 216}
 217
 218GIT_EXIT_OK=
 219trap 'die' EXIT
 220
 221# The semantics of the editor variables are that of invoking
 222# sh -c "$EDITOR \"$@\"" files ...
 223#
 224# If our trash directory contains shell metacharacters, they will be
 225# interpreted if we just set $EDITOR directly, so do a little dance with
 226# environment variables to work around this.
 227#
 228# In particular, quoting isn't enough, as the path may contain the same quote
 229# that we're using.
 230test_set_editor () {
 231        FAKE_EDITOR="$1"
 232        export FAKE_EDITOR
 233        EDITOR='"$FAKE_EDITOR"'
 234        export EDITOR
 235}
 236
 237test_decode_color () {
 238        sed     -e 's/.\[1m/<WHITE>/g' \
 239                -e 's/.\[31m/<RED>/g' \
 240                -e 's/.\[32m/<GREEN>/g' \
 241                -e 's/.\[33m/<YELLOW>/g' \
 242                -e 's/.\[34m/<BLUE>/g' \
 243                -e 's/.\[35m/<MAGENTA>/g' \
 244                -e 's/.\[36m/<CYAN>/g' \
 245                -e 's/.\[m/<RESET>/g'
 246}
 247
 248q_to_nul () {
 249        perl -pe 'y/Q/\000/'
 250}
 251
 252q_to_cr () {
 253        tr Q '\015'
 254}
 255
 256append_cr () {
 257        sed -e 's/$/Q/' | tr Q '\015'
 258}
 259
 260remove_cr () {
 261        tr '\015' Q | sed -e 's/Q$//'
 262}
 263
 264test_tick () {
 265        if test -z "${test_tick+set}"
 266        then
 267                test_tick=1112911993
 268        else
 269                test_tick=$(($test_tick + 60))
 270        fi
 271        GIT_COMMITTER_DATE="$test_tick -0700"
 272        GIT_AUTHOR_DATE="$test_tick -0700"
 273        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 274}
 275
 276# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 277#
 278# This will commit a file with the given contents and the given commit
 279# message.  It will also add a tag with <message> as name.
 280#
 281# Both <file> and <contents> default to <message>.
 282
 283test_commit () {
 284        file=${2:-"$1.t"}
 285        echo "${3-$1}" > "$file" &&
 286        git add "$file" &&
 287        test_tick &&
 288        git commit -m "$1" &&
 289        git tag "$1"
 290}
 291
 292# Call test_merge with the arguments "<message> <commit>", where <commit>
 293# can be a tag pointing to the commit-to-merge.
 294
 295test_merge () {
 296        test_tick &&
 297        git merge -m "$1" "$2" &&
 298        git tag "$1"
 299}
 300
 301# This function helps systems where core.filemode=false is set.
 302# Use it instead of plain 'chmod +x' to set or unset the executable bit
 303# of a file in the working directory and add it to the index.
 304
 305test_chmod () {
 306        chmod "$@" &&
 307        git update-index --add "--chmod=$@"
 308}
 309
 310# Use test_set_prereq to tell that a particular prerequisite is available.
 311# The prerequisite can later be checked for in two ways:
 312#
 313# - Explicitly using test_have_prereq.
 314#
 315# - Implicitly by specifying the prerequisite tag in the calls to
 316#   test_expect_{success,failure,code}.
 317#
 318# The single parameter is the prerequisite tag (a simple word, in all
 319# capital letters by convention).
 320
 321test_set_prereq () {
 322        satisfied="$satisfied$1 "
 323}
 324satisfied=" "
 325
 326test_have_prereq () {
 327        case $satisfied in
 328        *" $1 "*)
 329                : yes, have it ;;
 330        *)
 331                ! : nope ;;
 332        esac
 333}
 334
 335# You are not expected to call test_ok_ and test_failure_ directly, use
 336# the text_expect_* functions instead.
 337
 338test_ok_ () {
 339        test_success=$(($test_success + 1))
 340        say_color "" "  ok $test_count: $@"
 341}
 342
 343test_failure_ () {
 344        test_failure=$(($test_failure + 1))
 345        say_color error "FAIL $test_count: $1"
 346        shift
 347        echo "$@" | sed -e 's/^/        /'
 348        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 349}
 350
 351test_known_broken_ok_ () {
 352        test_fixed=$(($test_fixed+1))
 353        say_color "" "  FIXED $test_count: $@"
 354}
 355
 356test_known_broken_failure_ () {
 357        test_broken=$(($test_broken+1))
 358        say_color skip "  still broken $test_count: $@"
 359}
 360
 361test_debug () {
 362        test "$debug" = "" || eval "$1"
 363}
 364
 365test_run_ () {
 366        eval >&3 2>&4 "$1"
 367        eval_ret="$?"
 368        return 0
 369}
 370
 371test_skip () {
 372        test_count=$(($test_count+1))
 373        to_skip=
 374        for skp in $GIT_SKIP_TESTS
 375        do
 376                case $this_test.$test_count in
 377                $skp)
 378                        to_skip=t
 379                esac
 380        done
 381        if test -z "$to_skip" && test -n "$prereq" &&
 382           ! test_have_prereq "$prereq"
 383        then
 384                to_skip=t
 385        fi
 386        case "$to_skip" in
 387        t)
 388                say_color skip >&3 "skipping test: $@"
 389                say_color skip "skip $test_count: $1"
 390                : true
 391                ;;
 392        *)
 393                false
 394                ;;
 395        esac
 396}
 397
 398test_expect_failure () {
 399        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 400        test "$#" = 2 ||
 401        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 402        if ! test_skip "$@"
 403        then
 404                say >&3 "checking known breakage: $2"
 405                test_run_ "$2"
 406                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 407                then
 408                        test_known_broken_ok_ "$1"
 409                else
 410                        test_known_broken_failure_ "$1"
 411                fi
 412        fi
 413        echo >&3 ""
 414}
 415
 416test_expect_success () {
 417        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 418        test "$#" = 2 ||
 419        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 420        if ! test_skip "$@"
 421        then
 422                say >&3 "expecting success: $2"
 423                test_run_ "$2"
 424                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 425                then
 426                        test_ok_ "$1"
 427                else
 428                        test_failure_ "$@"
 429                fi
 430        fi
 431        echo >&3 ""
 432}
 433
 434test_expect_code () {
 435        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 436        test "$#" = 3 ||
 437        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 438        if ! test_skip "$@"
 439        then
 440                say >&3 "expecting exit code $1: $3"
 441                test_run_ "$3"
 442                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 443                then
 444                        test_ok_ "$2"
 445                else
 446                        test_failure_ "$@"
 447                fi
 448        fi
 449        echo >&3 ""
 450}
 451
 452# test_external runs external test scripts that provide continuous
 453# test output about their progress, and succeeds/fails on
 454# zero/non-zero exit code.  It outputs the test output on stdout even
 455# in non-verbose mode, and announces the external script with "* run
 456# <n>: ..." before running it.  When providing relative paths, keep in
 457# mind that all scripts run in "trash directory".
 458# Usage: test_external description command arguments...
 459# Example: test_external 'Perl API' perl ../path/to/test.pl
 460test_external () {
 461        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 462        test "$#" = 3 ||
 463        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 464        descr="$1"
 465        shift
 466        if ! test_skip "$descr" "$@"
 467        then
 468                # Announce the script to reduce confusion about the
 469                # test output that follows.
 470                say_color "" " run $test_count: $descr ($*)"
 471                # Run command; redirect its stderr to &4 as in
 472                # test_run_, but keep its stdout on our stdout even in
 473                # non-verbose mode.
 474                "$@" 2>&4
 475                if [ "$?" = 0 ]
 476                then
 477                        test_ok_ "$descr"
 478                else
 479                        test_failure_ "$descr" "$@"
 480                fi
 481        fi
 482}
 483
 484# Like test_external, but in addition tests that the command generated
 485# no output on stderr.
 486test_external_without_stderr () {
 487        # The temporary file has no (and must have no) security
 488        # implications.
 489        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 490        stderr="$tmp/git-external-stderr.$$.tmp"
 491        test_external "$@" 4> "$stderr"
 492        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 493        descr="no stderr: $1"
 494        shift
 495        say >&3 "expecting no stderr from previous command"
 496        if [ ! -s "$stderr" ]; then
 497                rm "$stderr"
 498                test_ok_ "$descr"
 499        else
 500                if [ "$verbose" = t ]; then
 501                        output=`echo; echo Stderr is:; cat "$stderr"`
 502                else
 503                        output=
 504                fi
 505                # rm first in case test_failure exits.
 506                rm "$stderr"
 507                test_failure_ "$descr" "$@" "$output"
 508        fi
 509}
 510
 511# This is not among top-level (test_expect_success | test_expect_failure)
 512# but is a prefix that can be used in the test script, like:
 513#
 514#       test_expect_success 'complain and die' '
 515#           do something &&
 516#           do something else &&
 517#           test_must_fail git checkout ../outerspace
 518#       '
 519#
 520# Writing this as "! git checkout ../outerspace" is wrong, because
 521# the failure could be due to a segv.  We want a controlled failure.
 522
 523test_must_fail () {
 524        "$@"
 525        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 526}
 527
 528# test_cmp is a helper function to compare actual and expected output.
 529# You can use it like:
 530#
 531#       test_expect_success 'foo works' '
 532#               echo expected >expected &&
 533#               foo >actual &&
 534#               test_cmp expected actual
 535#       '
 536#
 537# This could be written as either "cmp" or "diff -u", but:
 538# - cmp's output is not nearly as easy to read as diff -u
 539# - not all diff versions understand "-u"
 540
 541test_cmp() {
 542        $GIT_TEST_CMP "$@"
 543}
 544
 545# Most tests can use the created repository, but some may need to create more.
 546# Usage: test_create_repo <directory>
 547test_create_repo () {
 548        test "$#" = 1 ||
 549        error "bug in the test script: not 1 parameter to test-create-repo"
 550        owd=`pwd`
 551        repo="$1"
 552        mkdir -p "$repo"
 553        cd "$repo" || error "Cannot setup test environment"
 554        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 555        error "cannot run git init -- have you built things yet?"
 556        mv .git/hooks .git/hooks-disabled
 557        cd "$owd"
 558}
 559
 560test_done () {
 561        GIT_EXIT_OK=t
 562        test_results_dir="$TEST_DIRECTORY/test-results"
 563        mkdir -p "$test_results_dir"
 564        test_results_path="$test_results_dir/${0%.sh}-$$"
 565
 566        echo "total $test_count" >> $test_results_path
 567        echo "success $test_success" >> $test_results_path
 568        echo "fixed $test_fixed" >> $test_results_path
 569        echo "broken $test_broken" >> $test_results_path
 570        echo "failed $test_failure" >> $test_results_path
 571        echo "" >> $test_results_path
 572
 573        if test "$test_fixed" != 0
 574        then
 575                say_color pass "fixed $test_fixed known breakage(s)"
 576        fi
 577        if test "$test_broken" != 0
 578        then
 579                say_color error "still have $test_broken known breakage(s)"
 580                msg="remaining $(($test_count-$test_broken)) test(s)"
 581        else
 582                msg="$test_count test(s)"
 583        fi
 584        case "$test_failure" in
 585        0)
 586                say_color pass "passed all $msg"
 587
 588                test -d "$remove_trash" &&
 589                cd "$(dirname "$remove_trash")" &&
 590                rm -rf "$(basename "$remove_trash")"
 591
 592                exit 0 ;;
 593
 594        *)
 595                say_color error "failed $test_failure among $msg"
 596                exit 1 ;;
 597
 598        esac
 599}
 600
 601# Test the binaries we have just built.  The tests are kept in
 602# t/ subdirectory and are run in 'trash directory' subdirectory.
 603TEST_DIRECTORY=$(pwd)
 604if test -n "$valgrind"
 605then
 606        make_symlink () {
 607                test -h "$2" &&
 608                test "$1" = "$(readlink "$2")" || {
 609                        # be super paranoid
 610                        if mkdir "$2".lock
 611                        then
 612                                rm -f "$2" &&
 613                                ln -s "$1" "$2" &&
 614                                rm -r "$2".lock
 615                        else
 616                                while test -d "$2".lock
 617                                do
 618                                        say "Waiting for lock on $2."
 619                                        sleep 1
 620                                done
 621                        fi
 622                }
 623        }
 624
 625        make_valgrind_symlink () {
 626                # handle only executables
 627                test -x "$1" || return
 628
 629                base=$(basename "$1")
 630                symlink_target=$TEST_DIRECTORY/../$base
 631                # do not override scripts
 632                if test -x "$symlink_target" &&
 633                    test ! -d "$symlink_target" &&
 634                    test "#!" != "$(head -c 2 < "$symlink_target")"
 635                then
 636                        symlink_target=../valgrind.sh
 637                fi
 638                case "$base" in
 639                *.sh|*.perl)
 640                        symlink_target=../unprocessed-script
 641                esac
 642                # create the link, or replace it if it is out of date
 643                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 644        }
 645
 646        # override all git executables in TEST_DIRECTORY/..
 647        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 648        mkdir -p "$GIT_VALGRIND"/bin
 649        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 650        do
 651                make_valgrind_symlink $file
 652        done
 653        OLDIFS=$IFS
 654        IFS=:
 655        for path in $PATH
 656        do
 657                ls "$path"/git-* 2> /dev/null |
 658                while read file
 659                do
 660                        make_valgrind_symlink "$file"
 661                done
 662        done
 663        IFS=$OLDIFS
 664        PATH=$GIT_VALGRIND/bin:$PATH
 665        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 666        export GIT_VALGRIND
 667elif test -n "$GIT_TEST_INSTALLED" ; then
 668        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 669        error "Cannot run git from $GIT_TEST_INSTALLED."
 670        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 671        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 672else # normal case, use ../bin-wrappers only unless $with_dashes:
 673        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 674        if ! test -x "$git_bin_dir/git" ; then
 675                if test -z "$with_dashes" ; then
 676                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 677                fi
 678                with_dashes=t
 679        fi
 680        PATH="$git_bin_dir:$PATH"
 681        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 682        if test -n "$with_dashes" ; then
 683                PATH="$TEST_DIRECTORY/..:$PATH"
 684        fi
 685fi
 686GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 687unset GIT_CONFIG
 688GIT_CONFIG_NOSYSTEM=1
 689GIT_CONFIG_NOGLOBAL=1
 690export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 691
 692. ../GIT-BUILD-OPTIONS
 693
 694GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 695export GITPERLLIB
 696test -d ../templates/blt || {
 697        error "You haven't built things yet, have you?"
 698}
 699
 700if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 701then
 702        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 703        export GITPYTHONLIB
 704        test -d ../git_remote_helpers/build || {
 705                error "You haven't built git_remote_helpers yet, have you?"
 706        }
 707fi
 708
 709if ! test -x ../test-chmtime; then
 710        echo >&2 'You need to build test-chmtime:'
 711        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 712        exit 1
 713fi
 714
 715# Test repository
 716test="trash directory.$(basename "$0" .sh)"
 717test -n "$root" && test="$root/$test"
 718case "$test" in
 719/*) TRASH_DIRECTORY="$test" ;;
 720 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 721esac
 722test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 723rm -fr "$test" || {
 724        GIT_EXIT_OK=t
 725        echo >&5 "FATAL: Cannot prepare test area"
 726        exit 1
 727}
 728
 729test_create_repo "$test"
 730# Use -P to resolve symlinks in our working directory so that the cwd
 731# in subprocesses like git equals our $PWD (for pathname comparisons).
 732cd -P "$test" || exit 1
 733
 734this_test=${0##*/}
 735this_test=${this_test%%-*}
 736for skp in $GIT_SKIP_TESTS
 737do
 738        to_skip=
 739        for skp in $GIT_SKIP_TESTS
 740        do
 741                case "$this_test" in
 742                $skp)
 743                        to_skip=t
 744                esac
 745        done
 746        case "$to_skip" in
 747        t)
 748                say_color skip >&3 "skipping test $this_test altogether"
 749                say_color skip "skip all tests in $this_test"
 750                test_done
 751        esac
 752done
 753
 754# Provide an implementation of the 'yes' utility
 755yes () {
 756        if test $# = 0
 757        then
 758                y=y
 759        else
 760                y="$*"
 761        fi
 762
 763        while echo "$y"
 764        do
 765                :
 766        done
 767}
 768
 769# Fix some commands on Windows
 770case $(uname -s) in
 771*MINGW*)
 772        # Windows has its own (incompatible) sort and find
 773        sort () {
 774                /usr/bin/sort "$@"
 775        }
 776        find () {
 777                /usr/bin/find "$@"
 778        }
 779        sum () {
 780                md5sum "$@"
 781        }
 782        # git sees Windows-style pwd
 783        pwd () {
 784                builtin pwd -W
 785        }
 786        # no POSIX permissions
 787        # backslashes in pathspec are converted to '/'
 788        # exec does not inherit the PID
 789        ;;
 790*)
 791        test_set_prereq POSIXPERM
 792        test_set_prereq BSLASHPSPEC
 793        test_set_prereq EXECKEEPSPID
 794        ;;
 795esac
 796
 797test -z "$NO_PERL" && test_set_prereq PERL
 798test -z "$NO_PYTHON" && test_set_prereq PYTHON
 799
 800# test whether the filesystem supports symbolic links
 801ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 802rm -f y